﻿@page "/chatbots"
@using Syncfusion.Blazor.Grids

<PageTitle>JWobot Admin | ChatBots</PageTitle>

<div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">ChatBots</h1>
</div>

@if (isAdmin)
{
    <div class="row">
        <div class="col mb-3">
            <a href="/chatbots/create" class="btn btn-primary float-right">Create Chatbot</a>
        </div>
    </div>
}
<div class="row">
    <div class="col">
        <SfGrid ID="Grid" @ref="Grid" DataSource="@ChatBots" AllowGrouping="true" AllowSorting="true" AllowPaging="true" AllowResizing="true" AllowFiltering="true" Toolbar="@(new List<string>() { "Search", "ExcelExport", "CsvExport", "PdfExport", "ColumnChooser" })" ShowColumnChooser="true" AllowReordering="true" AllowExcelExport="true" AllowPdfExport="true">
            <GridFilterSettings Type="Syncfusion.Blazor.Grids.FilterType.Menu"></GridFilterSettings>
            <GridEvents OnToolbarClick="ToolbarClick" TValue="ChatBotListModel"></GridEvents>
            <GridPageSettings PageCount="5" PageSizes="true"></GridPageSettings>
            <GridColumns>
                <GridColumn Field=@nameof(ChatBotListModel.Name) HeaderText="Name"></GridColumn>
                <GridColumn Field=@nameof(ChatBotListModel.Company) HeaderText="Company" AutoFit="true"></GridColumn>
                <GridColumn Field=@nameof(ChatBotListModel.Token) HeaderText="Token" AutoFit="true"></GridColumn>
                <GridColumn Field=@nameof(ChatBotListModel.Active) HeaderText="Active" AutoFit="true"></GridColumn>
                <GridColumn AutoFit="true" TextAlign="TextAlign.Center">
                    <Template>
                        @{
                            var cb = (context as ChatBotListModel);
                            <a href="/chatbots/@cb.Id/edit"><i class="fa fa-edit"></i></a>
                        }
                    </Template>
                </GridColumn>
            </GridColumns>
        </SfGrid>
    </div>
</div>
@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private bool isAdmin = false;

    SfGrid<ChatBotListModel> Grid;
    public List<ChatBotListModel> ChatBots { get; set; }
    protected async override Task OnInitializedAsync()
    {
        await JS.ShowLoader();
        var claimsPrincipal = (await authenticationStateTask).User;
        if (claimsPrincipal != null)
        {
            isAdmin = claimsPrincipal.IsInRole("Admin");
        }

        if (isAdmin)
        {
            ChatBots = Mapper.Map<List<ChatBotListModel>>(ChatBotService.GetAll().ToList());

        }
        else
        {
            ChatBots = Mapper.Map<List<ChatBotListModel>>(ChatBotService.GetByUserId(int.Parse(claimsPrincipal.Identity.Name)).ToList());
        }
        await JS.HideLoader();
    }

    public void ToolbarClick(Syncfusion.Blazor.Navigations.ClickEventArgs args)
    {
        if (args.Item.Id == "Grid_pdfexport")
        {
            this.Grid.PdfExport();
        }
        if (args.Item.Id == "Grid_excelexport")
        {
            this.Grid.ExcelExport();
        }
        if (args.Item.Id == "Grid_csvexport")
        {
            this.Grid.CsvExport();
        }
    }
}
